from callback.Callback import Callback
from matrix_wrapper import *
from callback.callbacks import ListDirectoriesCallback

class ListDirectoriesCallback(Callback):
    BASE_DIR = os.environ["BASE_DIR"]
    ACTION_NAME = "lsdir"


    async def run(self, args: dict):
        subdirs = {}
        directories = args.get(Callback.NO_PARAM)

        if not directories:
            subdirs.update({ListDirectoriesCallback.BASE_DIR: self.get_immediate_subdirectories(ListDirectoriesCallback.BASE_DIR)})
        else:
            for directory in directories:
                try:
                    full_directory = "{}/{}".format(ListDirectoriesCallback.BASE_DIR, directory)
                    subdirs.update({directory: self.get_immediate_subdirectories(full_directory)})
                except Exception as e:
                    await send_message("error encountered: {}".format(e))
                    return
        
        message = """<h2>List Directories</h2>
<table>
    <tr>
        <th>Directory</th>
        <th>Subdirectories</th>
    </tr>
    """
        for key, value in subdirs.items():
            message += "<tr><td>{}</td><td>".format(key)
            for subdir in value:
                message += "{}<br/>".format(subdir)

            message += "</td></tr>"
        message += "</table>"

        await send_html(message)

    def get_immediate_subdirectories(directory: str):
        return [name for name in os.listdir(directory)
                if os.path.isdir(os.path.join(directory, name))]