import matrix_wrapper
import asyncio
from Timer import Timer
from Task import Task
from TaskGroup import TaskGroup
from callback import callback_helper
from callback.callbacks.HelpCallback import HelpCallback
from callback.callbacks.DiskUsageCallback import DiskUsageCallback
from callback.callbacks.ListDirectoriesCallback import ListDirectoriesCallback
from callback.callbacks.TimerCallback import TimerCallback
from callback.callbacks.TaskCallback import TaskCallback
from callback.callbacks.TaskGroupCallback import TaskGroupCallback


async def main():
    # callbacks

    callback_helper.register(DiskUsageCallback.ACTION_NAME, DiskUsageCallback)
    callback_helper.register(HelpCallback.ACTION_NAME, HelpCallback)
    callback_helper.register(ListDirectoriesCallback.ACTION_NAME, ListDirectoriesCallback)
    callback_helper.register(TimerCallback.ACTION_NAME, TimerCallback)
    callback_helper.register(TaskCallback.ACTION_NAME, TaskCallback)
    callback_helper.register(TaskGroupCallback.ACTION_NAME, TaskGroupCallback)

    # setup communication
    await matrix_wrapper.init()
    await matrix_wrapper.login()

    # restore backups
    await Timer.restartExisting()
    await Task.restartExisting()
    await TaskGroup.restartExisting()

    await matrix_wrapper.listen_messages()


if __name__ == "__main__":
    asyncio.get_event_loop().run_until_complete(main())
    